#include "ChafKitAuth.h"

using namespace ChafKitCore;

TChafKitResult<TSharedPtr<ChafProfile>> ChafKitAuth::GetProfile()
{
    const ChafKitCore::Profile *ProfileHandle;
    ChafKitCore::ChafKitResult Result = chafkit_auth_get_profile(&ProfileHandle);

    if (Result == ChafKitCore::ChafKitResult::Ok)
    {
        TSharedPtr<ChafProfile> profile = MakeShareable(new ChafProfile(ProfileHandle));
        return TChafKitResult<TSharedPtr<ChafProfile>>::Success(profile);
    }
    else
    {
        return TChafKitResult<TSharedPtr<ChafProfile>>::Failure(Result);
    }
}

TSharedPtr<FOnExternalTokenIssued> ChafKitAuth::IssueExternalToken()
{
    static auto callback = MakeShared<FOnExternalTokenIssued>();
    CallbackHandle handle = chafkit_auth_issue_external_token();
    chafkit_callback_handle_set_callback(
        handle,
        [](const CallbackResultUnion *result, CallbackHandle innerHandle)
        {
            callback->ExecuteIfBound(result->external_token_issued);
        });
    return callback;
}
