#include "ChafKitSDK.h"

using namespace ChafKitCore;

TSharedPtr<FOnChafKitInitialized> ChafKitSDK::Initialize(const FString &GameId)
{
    const TCHAR *TCHARArray = *GameId;
    static auto callback = MakeShared<FOnChafKitInitialized>();
    std::string ANSIString(TCHAR_TO_UTF8(TCHARArray));
    CallbackHandle handle = chafkit_initialize(ANSIString.c_str());
    chafkit_callback_handle_set_callback(
        handle,
        [](const CallbackResultUnion *result, CallbackHandle innerHandle)
        {
            callback->ExecuteIfBound(result->chafkit_initialized);
        });
    return callback;
}

bool ChafKitSDK::Shutdown()
{
    return chafkit_shutdown();
}