#include "ChafProfile.h"

using namespace ChafKitCore;

ChafProfile::ChafProfile(const ChafKitCore::Profile *Handle)
    : Handle(Handle)
{
}

TChafKitResult<FString> ChafProfile::GetUsername()
{
    const char *Username;
    ChafKitResult Result = chafkit_profile_get_username(Handle, &Username);
    if (Result == ChafKitResult::Ok)
    {
        return TChafKitResult<FString>::Success(FString(UTF8_TO_TCHAR(Username)));
    }
    return TChafKitResult<FString>::Failure(Result);
}

TChafKitResult<FString> ChafProfile::GetDisplayName()
{
    const char *DisplayName;
    ChafKitResult Result = chafkit_profile_get_display_name(Handle, &DisplayName);
    if (Result == ChafKitResult::Ok)
    {
        return TChafKitResult<FString>::Success(FString(UTF8_TO_TCHAR(DisplayName)));
    }
    return TChafKitResult<FString>::Failure(Result);
}

TChafKitResult<FString> ChafProfile::GetUserId()
{
    const char *UserId;
    ChafKitResult Result = chafkit_profile_get_user_id(Handle, &UserId);
    if (Result == ChafKitResult::Ok)
    {
        return TChafKitResult<FString>::Success(FString(UTF8_TO_TCHAR(UserId)));
    }
    return TChafKitResult<FString>::Failure(Result);
}

TChafKitResult<FString> ChafProfile::GetPhoto()
{
    const char *Photo;
    ChafKitResult Result = chafkit_profile_get_photo(Handle, &Photo);
    if (Result == ChafKitResult::Ok)
    {
        return TChafKitResult<FString>::Success(FString(UTF8_TO_TCHAR(Photo)));
    }
    return TChafKitResult<FString>::Failure(Result);
}
