// Fill out your copyright notice in the Description page of Project Settings.

using System.IO;
using UnrealBuildTool;

public class ChafKitCore : ModuleRules
{
    public ChafKitCore(ReadOnlyTargetRules Target) : base(Target)
    {
        Type = ModuleType.External;

        if (Target.Platform == UnrealTargetPlatform.Win64)
        {
            string dllPath = Path.Combine("$(PluginDir)", "Binaries", "ThirdParty", "ChafKitCore", "Win64", "chafkit_core.dll");
            string libPath = Path.Combine("$(PluginDir)", "Binaries", "ThirdParty", "ChafKitCore", "Win64", "chafkit_core.dll.lib");
            PublicAdditionalLibraries.Add(libPath);
            PublicDelayLoadDLLs.Add("chafkit_core.dll");
            RuntimeDependencies.Add(dllPath);
        }
        else if (Target.Platform == UnrealTargetPlatform.Mac)
        {
            // PublicDelayLoadDLLs.Add(Path.Combine(ModuleDirectory, "Mac", "Release", "libExampleLibrary.dylib"));
            // RuntimeDependencies.Add("$(PluginDir)/Source/ThirdParty/ChafKitLibrary/Mac/Release/libExampleLibrary.dylib");
        }
        else if (Target.Platform == UnrealTargetPlatform.Linux)
        {
            // string ExampleSoPath = Path.Combine("$(PluginDir)", "Binaries", "ThirdParty", "ChafKitLibrary", "Linux", "x86_64-unknown-linux-gnu", "libExampleLibrary.so");
            // PublicAdditionalLibraries.Add(ExampleSoPath);
            // PublicDelayLoadDLLs.Add(ExampleSoPath);
            // RuntimeDependencies.Add(ExampleSoPath);
        }
    }
}
